-- addon : nom de l'addon, field : info du .toc ("version", "title", "author"...)
-- return :  String - The value of the field, nil if not defined
local function GetAddOnMetadataPers(addon, field)
	return GetAddOnMetadata(addon, field)
end

-- return : itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice
local function GetItemInfoPers(item)
	return GetItemInfo(item)
end

-- prefix : prefix crée, text : le texte qu'on veut envoyer, type : channel (raid, guild, party...)
local function SendAddonMessagePers(prefix, text, type)
	SendAddonMessage(prefix, text, type)
end

-- return : Integer - the number of slots in the specified bag, or 0 if there is no bag in the given slot.
local function GetContainerNumSlotsPers(bagID)
	return GetContainerNumSlots(bagID)
end

-- unit : "player", "target", etc...      slot : slot number
-- return : link - An item link for the given item (string, hyperlink)
local function GetInventoryItemLinkPers(unit, slot)
	return GetInventoryItemLink(unit, slot)
end

-- slotName : The InventorySlotName to query ("HEADSLOT", etc) - string
--return : id, texture, checkRelic
local function GetInventorySlotInfoPers(slotName)
	return GetInventorySlotInfo(slotName)
end

-- container (le sac) : int, slot (le slot dans le sac) : int
-- return : link of the object or nil
local function GetContainerItemLinkPers(container, slot)
	return GetContainerItemLink(container, slot)
end

-- return : Returns the item id of the item in a particular container slot.
local function GetContainerItemIDPers(bag, slot)
	return GetContainerItemID(bag, slot)
end

-- return : Number of available quest rewards (number)
local function GetNumQuestChoicesPers()
	return GetNumQuestChoices()
end


local function GetQuestRewardPers(choice)
	--print("choix : "..tostring(choice))
	GetQuestReward(choice)
end
-- type : "required", "reward" or "choice", index : int
-- return : The link to the quest item specified.
local function GetQuestItemLinkPers(type, index)
	return GetQuestItemLink(type, index)
end

-- return : id of current spec
local function GetSpecializationPers()
	return GetSpecialization()
end

--							isInspect, 	 isPet
-- GetSpecializationPers(), false,       false, UnitName("player"), UnitSex("player")
-- return : id, name, description, icon, background, role
local function GetSpecializationInfoPers(speID, bool1, bool2, target, gender)
	return GetSpecializationInfo(speID, bool1, bool2, gender)
end

-- return : texture (string), name (string), count (integer), quality (integer), bindOnPickUp (boolean), canNeed (boolean), canGreed (boolean), canDisenchant (boolean)
local function GetLootRollItemInfoPers(rollID)
	return GetLootRollItemInfo(rollID)
end

-- rolltype : 1 : Need roll 	2 : Greed roll 		3 : Disenchant roll
local function ConfirmLootRollPers(rollID, rollType)
	ConfirmLootRoll(rollID, rollType)
end

-- return : spécialisation du butin
local function GetLootSpecializationPers()
	return GetLootSpecialization()
end

-- bagID, slot
local function UseContainerItemPers(bagID, slot)
	UseContainerItem(bagID, slot)
end





      -------------------- Définition des variables --------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

-- NE PAS OUBLIER DE RAJOUTER LA VERSION PRÉCÉDENTE ICI APRÈS CHAQUE MISE A JOUR !!!!
local anciennesVersions = {"0.0", "0.1", "0.2", "0.3", "0.4", "0.5", "0.51", "0.6", "0.61", "0.7", "0.8", "0.9", "0.9.1", "1.0", "1.0.1", "1.0.2", "1.0.3", "1.1", "1.2"}	

addonName, GH_Globals=...
addonName = "GearHelper"
frameInterface = ...

local version = GetAddOnMetadataPers(addonName, "Version")
local versionCible = nil
--print("Version actuelle : "..version)
local prefix = "GeARHeLPeRPReFIX"--..version -- rajouter version si on veut que notre addon ne comunique QUE avec les GH de la même version
-- ^ Pour le préfix, choisir un nom qu'on est sûr que personne d'autre ne réutilisera
local L = GearHelperLocalization -- permet de récupérer le text dans toutes les langues

local allEvents = {}
local allPrefix = {["askVersion"..prefix] = sendAnswerVersion, ["answerVersion"..prefix] = receiveAnswer,}
local nbSlotsBag = {[0] = 0, [1] = 0, [2] = 0, [3] = 0, [4] = 0}
local eventHandler, waitAnswerFrame, loadFrame = CreateFrame("Frame"), CreateFrame("Frame"), CreateFrame("Frame")
local askTime, maxWaitTime = nil, 15
local bagInventory = {}
local charInventory = {}

local specialisationID, specName, description, icon, background, role, primaryStat = nil


local waitEquipFrame = CreateFrame("Frame")
local waitEquipTimer = nil
local waitSpeFrame = CreateFrame("Frame")
local waitSpeTimer = nil
local numBag = 0

local nbRappels = 3

--local id, name, description, icon, background, role, primaryStat = GetSpecializationInfoPers(GetSpecializationPers(), false, false, UnitName("player"), UnitSex("player"))
templateWeight = ...

local function getSubTypeStuff( idItem )
	local _, _, _, _, _, _, itemSubType = GetItemInfoPers(idItem)
	return itemSubType
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
      ----------------- Fin de définition des variables -----------------

      waitAnswerFrame:Hide()
      waitEquipFrame:Hide()
      waitSpeFrame:Hide()

-- Initialise la variable sur true la première fois qu'on utilise l'addon
-- Variable par perso, permet d'avoir différents profils
local function setDefault()
	if GHActivated == nil then
		GHActivated = true
		print(L["addonActivated"])
	end
	if GHSellGreyActivated == nil then
		GHSellGreyActivated = true
		print(L["sellGreyActivated"])
	end
	if GHAutoGreed == nil then
		GHAutoGreed = true
		print(L["autoGreedActivated"])
	end
	if GHAutoAcceptQuestReward == nil then
		GHAutoAcceptQuestReward = false
		print(L["autoAcceptQuestRewardDeactivated"])
	end
	if GHAutoNeed == nil then
		GHAutoNeed = false
		print(L["autoNeedInstanceLootDeactivated"])
	end
	if GHAutoEquipLootStuff == nil then
		GHAutoEquipLootStuff = true
		print(L["autoEquipLootStuffDeactivated"])
	end
	if GHAutoEquipWhenChangeSpe == nil then
		GHAutoEquipWhenChangeSpe = true
		print(L["autoEquipWhenChangeSpeActivated"])
	end
	if GHAMR == nil then
		GHAMR = 0
	end
	if GHMinimapButton == nil then
		GHMinimapButton = true
	end
	if GHAutoRepair == nil then
		setGHAutoRepair(0)
		-- 0 = do not repair, 1 = repair, 2 = guild repair
	end


	InterfaceOptionsFrame_OpenToCategory(frameInterface)
	InterfaceOptionsFrame_OpenToCategory(frameInterface)

end

-- desc : Permet de changer l'état (on / off) de l'addon
-- entrée : booleen (true / false)
-- sortie : string (message indiquant si l'addon est sur on ou off)
-- commentaire :
local function setActivated( valeur )
	if valeur == true then
		GHActivated = true
		print(L["setOn"])
	elseif valeur == false then
		GHActivated = false
		print(L["setOff"])
	else
		print(L["errorSetActivatedValue"])
	end
end

-- permet d'activer/désactiver la vente d'objets gris
local function setGHSellGreyActivated( valeur )
	if valeur == true then
		GHSellGreyActivated = true
		print(L["setSGOn"])
	elseif valeur == false then
		GHSellGreyActivated = false
		print(L["setSGOff"])
	else
		print(L["errorSetSGActivatedValue"])
	end
end

-- permet d'activer / désactiver la cupidité automatique
local function setGHAutoGreed( valeur )
	if valeur == true and GHAutoGreed == false then
		GHAutoGreed = true
		print(L["autoGreedActivated"])
	elseif valeur == false and GHAutoGreed == true then
		GHAutoGreed = false
		print(L["autoGreedDeactivated"])
	end
end

local function setGHAutoAcceptQuestReward( valeur )
	if valeur == true and GHAutoAcceptQuestReward == false then
		GHAutoAcceptQuestReward = true
		print(L["autoAcceptQuestRewardActivated"])
	elseif valeur == false and GHAutoAcceptQuestReward == true then
		GHAutoAcceptQuestReward = false
		print(L["autoAcceptQuestRewardDeactivated"])
	end
end

local function setGHAutoNeed( valeur )
	if valeur == true and GHAutoNeed == false then
		GHAutoNeed = true
		print(L["autoNeedInstanceLootActivated"])
	elseif valeur == false and GHAutoNeed == true then
		GHAutoNeed = false
		print(L["autoNeedInstanceLootDeactivated"])
	end
end

local function setGHAutoEquipLootStuff( valeur )
	if valeur == true and GHAutoEquipLootStuff == false then
		GHAutoEquipLootStuff = true
		print(L["autoEquipLootStuffActivated"])
	elseif valeur == false and GHAutoEquipLootStuff == true then
		GHAutoEquipLootStuff = false
		print(L["autoEquipLootStuffDeactivated"])
	end
end

local function setGHAutoEquipWhenChangeSpe( valeur )
	if valeur == true and GHAutoEquipWhenChangeSpe == false then
		GHAutoEquipWhenChangeSpe = true
		print(L["autoEquipWhenChangeSpeActivated"])
	elseif valeur == false and GHAutoEquipWhenChangeSpe == true then
		GHAutoEquipWhenChangeSpe = false
		print(L["autoEquipWhenChangeSpeDeactivated"])
	end
end

local function setGHAutoRepair( valeur )
	if valeur == 0 then
		GHAutoRepair = 0
		print(L["GHAutoRepair0"])
	elseif valeur == 1 then
		GHAutoRepair = 1
		print(L["GHAutoRepair1"])
	elseif valeur == 2 then
		GHAutoRepair = 2
		print(L["GHAutoRepair2"])
	end
end

-- desc : Envoie dans la guilde / raid / groupe une demande aux autres GH pour savoir s'ils sont à jour
-- entrée : ø
-- sortie : ø
-- commentaire :
local function sendAskVersion()
	if UnitInRaid("player") ~= nil then
		SendAddonMessagePers(prefix, "askVersion;"..version, "RAID")
	end
	if IsInGuild() == true then
		SendAddonMessagePers(prefix, "askVersion;"..version, "GUILD")
	end
	if UnitInParty("player") then
		SendAddonMessagePers(prefix, "askVersion;"..version, "PARTY")
	end
	askTime = time()
	waitAnswerFrame:Show()
end

-- desc : Quand on reçoit une demande de version, l'addon utilise cette fonction qui envoit la réponse
-- entrée : ø
-- sortie : ø
-- commentaire :
local function sendAnswerVersion()
	if UnitInRaid("player") ~= nil then
		SendAddonMessagePers(prefix, "answerVersion;"..version, "RAID")
	end
	if IsInGuild() then
		SendAddonMessagePers(prefix, "answerVersion;"..version, "GUILD")
	end
	if UnitInParty("player") then
		SendAddonMessagePers(prefix, "answerVersion;"..version, "PARTY")
	end
end

-- desc : Vérifie si l'addon est à jour quand il recoit une réponse 
-- entrée : string (version de la cible), string (nom de la cible)
-- sortie : string (message si l'addon n'est pas à jour, sinon rien)
-- commentaire :
local function receiveAnswer( msgV, msgC )
	if askTime then
		--local answerCible = msgC:sub(msgC:find("-") - 1, #msgC)
		if nbRappels > 0 then
			if not isInTable(anciennesVersions, msgV) then
				if versionCible ~= version then
					if L["local"] == "FR" then
						print("Vous utilisez la version |cFFFF0000"..version.."|r de GearHelper. La version |cFF00FF00"..msgV.."|r a été trouvée chez "..msgC.." (Curse)")
					elseif L["local"] == "US" or L["local"] == "DE" then
						print("You are using version |cFFFF0000"..version.."|r of GearHelper. Version |cFF00FF00"..msgV.."|r was find from "..msgC.." (Curse)")
					end
					askTime = nil
					waitAnswerFrame:Hide()
					nbRappels = nbRappels - 1
				end
			end
		end
	end
end

	waitAnswerFrame:SetScript("OnUpdate", function ( self, elapsed )
		if askTime and (time() - askTime) > maxWaitTime then
			askTime = nil
			waitAnswerFrame:Hide()
		end
	end)

	waitEquipFrame:SetScript("OnUpdate", function ( self, elapsed )
		if time() > waitEquipTimer + 0.5 then
			equipItem()
			self:Hide()
		end
	end)
	waitSpeFrame:SetScript("OnUpdate", function ( self, elapsed )
		if time() > waitSpeTimer + 0.5 then
			--equipItem()
		specialisationID = GetSpecializationInfoPers(GetSpecializationPers(), false, false, UnitName("player"), UnitSex("player"))
		templateWeight = GH_Globals[specialisationID + GHAMR]
		--scanBag()

		for bag = 0,4 do
			numBag = bag
			equipItem()
		end
			self:Hide()
		end
	end)


-------------------------------------------------------------------------------
								-- FONCTIONS --
-------------------------------------------------------------------------------

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire : itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfoPers(itemID)
local function testSiObjetGris( itemID ) -- itemID ou itemLink ou itemName ou itemString
	local _, _, itemRarity = GetItemInfoPers(itemID)
	if itemRarity == 0 then
		return true
	else 
		return false
	end
	if itemRarity == nil then 
		return false
	end
end

-- desc :
-- entrée :
-- sortie :
-- commentaire : creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected, mountID  = C_MountJournal.GetDisplayedMountInfo(i)
-- commentaire : petID, speciesID, owned, customName, level, favorite, isRevoked, speciesName, icon, petType, companionID, tooltip, description, isWild, canBattle, isTradeable, isUnique, obtainable = C_PetJournal.GetPetInfoByIndex(i)
local function testSiMonture( lootName )

	-- test si monture
	local i = 1
	local creatureName  = C_MountJournal.GetDisplayedMountInfo(i)
	while creatureName ~= nil do
		if creatureName == lootName then
			return true
		end
		i = i + 1
		creatureName  = C_MountJournal.GetDisplayedMountInfo(i)
	end 

	-- test mascotte
	i = 1
	local _, _, owned, _, _, _, _, speciesName, _, _, _, _, _, _, _, isTradeable = C_PetJournal.GetPetInfoByIndex(i)
	while speciesName ~= nil do
		if creatureName == speciesName then
			if not owned then
				return true
			elseif owned and isTradeable then
				return true
			end
		end
		i = i+1
		_, _, owned, _, _, _, _, speciesName, _, _, _, _, _, _, _, isTradeable = C_PetJournal.GetPetInfoByIndex(i)
	end


	-- test jouet

	--test légendaire
	local _, _, itemRarity = GetItemInfo(lootName)
	if itemRarity ~= nil and itemRarity > 4 then
		return true
	end


	return false
end

local  function testSiUtilisable( idObjet )
	local _, _, _, _, _, itemType, _, _, itemEquipLoc, _, itemSellPrice = GetItemInfoPers(idObjet)
	if itemType == L["armor"] or itemType == L["weapon"] then
		if not IsDressableItem(idObjet) then
			if (itemSellPrice / 100 / 100) >= 1 then
				return false
			end
		end
	end
end

-- desc : Cette fonction permet de récupérer le nombre de slots dans l'inventaire du joueur
-- entrée : ø
-- sortie : ø
-- commentaire :
local function nbSlotsTotal()
	local nbSlots = 0
	local i = 0
	while i <= 4 do
		if GetContainerNumSlotsPers(i)  then
			nbSlots = nbSlots + GetContainerNumSlotsPers(i)
		end
		i = i + 1
	end
	return nbSlots
end

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :
local function scanCharacter()

	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("HeadSlot")) ~= nil then
		charInventory["Head"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("HeadSlot"))
	else
		charInventory["Head"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("NeckSlot")) ~= nil then
		charInventory["Neck"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("NeckSlot"))
	else
		charInventory["Neck"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("ShoulderSlot")) ~= nil then
		charInventory["Shoulder"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("ShoulderSlot"))
	else
		charInventory["Shoulder"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("BackSlot")) ~= nil then
		charInventory["Back"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("BackSlot"))
	else
		charInventory["Back"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("ChestSlot")) ~= nil then
		charInventory["Chest"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("ChestSlot"))
	else
		charInventory["Chest"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("WristSlot")) ~= nil then
		charInventory["Wrist"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("WristSlot"))
	else
		charInventory["Wrist"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("HandsSlot")) ~= nil then
		charInventory["Hands"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("HandsSlot"))
	else
		charInventory["Hands"] =  0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("WaistSlot")) ~= nil then
		charInventory["Waist"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("WaistSlot"))
	else
		charInventory["Waist"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("LegsSlot")) ~= nil then
		charInventory["Legs"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("LegsSlot"))
	else
		charInventory["Legs"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("FeetSlot")) ~= nil then
		charInventory["Feet"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("FeetSlot"))
	else
		charInventory["Feet"] =  0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("Finger0Slot")) ~= nil then
		charInventory["Finger0"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("Finger0Slot"))
	else
		charInventory["Finger0"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("Finger1Slot")) ~= nil then
		charInventory["Finger1"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("Finger1Slot"))
	else
		charInventory["Finger1"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("Trinket0Slot")) ~= nil then
		charInventory["Trinket0"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("Trinket0Slot"))
	else
		charInventory["Trinket0"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("Trinket1Slot")) ~= nil then
		charInventory["Trinket1"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("Trinket1Slot"))
	else
		charInventory["Trinket1"] = 0
	end
	if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("MainHandSlot")) ~= nil then
		charInventory["MainHand"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("MainHandSlot"))
		local _, _, _, _, _, _, _, _, itemEquipLocWeapon = GetItemInfoPers(charInventory["MainHand"])
		
		if itemEquipLocWeapon == "INVTYPE_2HWEAPON" or itemEquipLocWeapon == "INVTYPE_RANGED" then
			charInventory["SecondaryHand"] = -1
		else
			if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("SecondaryHandSlot")) ~= nil then
				charInventory["SecondaryHand"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("SecondaryHandSlot"))
			else
				charInventory["SecondaryHand"] = 0
			end
		end
	else
		charInventory["MainHand"] = 0

		if GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("SecondaryHandSlot")) ~= nil then
			charInventory["SecondaryHand"] = GetInventoryItemLinkPers("player",GetInventorySlotInfoPers("SecondaryHandSlot"))
		else
			charInventory["SecondaryHand"] = 0
		end
	end

end

-- desc : Fonction qui parse un link en ID
-- entrée : itemLink ( EX : |Hitem:124586:0:0:0:0:12254684455852 )
-- sortie : ID ( EX : 124586 )
-- commentaire :
local function parseID(link)
	local a = string.match(link, "item[%-?%d::]+")
	local b = string.sub(a, 5, 12)
	local c = string.gsub(b, ":", "")
	return c
end

local function diffItemValueTemplate(delta)
	local valueItem = 0
	local localizedClass, englishClass, classIndex = UnitClass("player")
	for stat, value in pairs(delta) do 
		--print(stat, value)
		if (stat == "ITEM_MOD_INTELLECT_SHORT" and templateWeight["Intellect"] ~= nil) then
			valueItem = valueItem + templateWeight["Intellect"] * value
		end
		if (stat == "ITEM_MOD_HASTE_RATING_SHORT"  and templateWeight["Haste"] ~= nil) then
			valueItem = valueItem + templateWeight["Haste"]*value
		end
		if (stat == "ITEM_MOD_CRIT_RATING_SHORT" and templateWeight["CriticalStrike"] ~= nil) then
			valueItem = valueItem + templateWeight["CriticalStrike"]*value
		end
		if (stat == "ITEM_MOD_STAMINA_SHORT" and templateWeight["Stamina"] ~= nil) then
			valueItem = valueItem + templateWeight["Stamina"]*value
		end
		if (stat == "ITEM_MOD_MASTERY_RATING_SHORT" and templateWeight["Mastery"] ~= nil) then
			valueItem = valueItem + templateWeight["Mastery"]*value
		end
		if (stat == "ITEM_MOD_VERSATILITY" and templateWeight["Versatility"] ~= nil) then
			valueItem = valueItem + templateWeight["Versatility"]*value
		end
		if (stat == "RESISTANCE0_NAME" and templateWeight["Armor"] ~= nil) then
			valueItem = valueItem + templateWeight["Armor"]*value
			--print(valueItem.." + "..templateWeight["Armor"].." * "..value.." = "..valueItem)
		end
		if (stat == "ITEM_MOD_HIT_RATING_SHORT" and templateWeight["Hit"] ~= nil) then
			valueItem = valueItem + templateWeight["Hit"]*value
		end
		if (stat == "ITEM_MOD_STRENGTH_SHORT" and templateWeight["Strength"] ~= nil) then
			valueItem = valueItem + templateWeight["Strength"] * value
		end
		if stat == "ITEM_MOD_AGILITY_SHORT" and templateWeight["Agility"] ~= nil then
			valueItem = valueItem + templateWeight["Agility"] * value
		end
		if (stat == "ITEM_MOD_CR_MULTISTRIKE_SHORT" and templateWeight["Multistrike"] ~= nil) then
			valueItem = valueItem + templateWeight["Multistrike"]*value
		end
		--print(_G[stat].." : "..value)
	end
	--print("valueItem : "..valueItem)
	--print(valueItem)
	return valueItem
end

local function isEquiped(itemLink)
	local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfoPers(itemLink)
	if itemEquipLoc == "INVTYPE_TRINKET" then
		if charInventory["Trinket0"] == itemLink or charInventory["Trinket1"] == itemLink then
			return true
		end
	elseif itemEquipLoc == "INVTYPE_FINGER" then
		if charInventory["Finger0"] == itemLink or charInventory["Finger1"] == itemLink then
			return true
		end
	elseif itemEquipLoc== "INVTYPE_WEAPON" then
		if charInventory["MainHand"] == itemLink or charInventory["SecondaryHand"] == itemLink then
			return true
		end
	else
		if charInventory[GH_Globals.itemSlot[itemEquipLoc]] == itemLink then
			return true
		end
	end
	return false
end

local function isPossibleEquip(itemLink)
	local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfoPers(itemLink)

	if itemEquipLoc == "INVTYPE_SHIELD" or itemEquipLoc == "INVTYPE_WEAPONOFFHAND" or itemEquipLoc == "INVTYPE_HOLDABLE" or itemEquipLoc== "INVTYPE_WEAPON" then
		if charInventory["SecondaryHand"] == -1 then
			return false
		end
	end
	
	return true
end

local function isSlotEmpty(equipLoc)
	local result = {}
	if equipLoc == "INVTYPE_TRINKET" then
		if charInventory["Trinket0"] == 0 then
			table.insert(result, true)
		else
			table.insert(result, false)
		end

		if charInventory["Trinket1"] == 0 then
			table.insert(result, true)
		else
			table.insert(result, false)
		end
	elseif equipLoc == "INVTYPE_FINGER" then
		if charInventory["Finger0"] == 0 then
			table.insert(result,true)
		else
			table.insert(result,false)
		end

		if charInventory["Finger1"] == 0 then
			table.insert(result, true)
		else
			table.insert(result, false)
		end
	elseif equipLoc == "INVTYPE_WEAPON" then
		if charInventory["MainHand"] == 0 then
			table.insert(result,true)
		else
			table.insert(result,false)
		end

		if charInventory["SecondaryHand"] == 0 then
			table.insert(result, true)
		else
			table.insert(result, false)
		end
	else
		if charInventory[GH_Globals.itemSlot[equipLoc]] == 0 then
			table.insert(result, true)
		else
			table.insert(result, false)
		end
	end
	return result
end

function weightCalculation(itemLink)
	if GHActivated == true then

		specID = GetLootSpecializationPers()
		if specID == 0 then
			specID = specialisationID
		end
		templateWeight = GH_Globals[specID + GHAMR]
		scanBag()

		local result = {}
		local playerSpec = specialisationID
		templateWeight = GH_Globals[playerSpec]
		if itemLink ~= nil then
			if isEquiped(itemLink) == false and isPossibleEquip(itemLink) then

				local _, lootItem, _, _, _, _, _, _, itemLootEquipLoc = GetItemInfoPers(itemLink)
				local _, _, itemRarity = GetItemInfoPers(itemLink)
				local tabSpec = GetItemSpecInfo(itemLink)
				local slotStatus = isSlotEmpty(itemLootEquipLoc)
				if tabSpec ~= nil then
					for a = 1, #tabSpec do
						if tabSpec[a] == playerSpec then
							if #slotStatus == 2 then
								local multipleSlot = GH_Globals.itemSlot[itemLootEquipLoc]
								for a = 1, #multipleSlot do
									if slotStatus[a] == false then
										local _, equipedItem = GetItemInfoPers(charInventory[multipleSlot[a]])
										table.insert(result, diffItemValueTemplate(GetItemStatDelta(lootItem, equipedItem)))
									else
										table.insert(result, diffItemValueTemplate(GetItemStats(lootItem)))
									end
								end
							else
								if slotStatus[1] == false then
									if charInventory[GH_Globals.itemSlot[itemLootEquipLoc]] ~= nil then
										local _, equipedItem = GetItemInfoPers(charInventory[GH_Globals.itemSlot[itemLootEquipLoc]])
										table.insert(result, diffItemValueTemplate(GetItemStatDelta(lootItem, equipedItem)))
									end
								else
									table.insert(result, diffItemValueTemplate(GetItemStats(lootItem)))
								end
							end
						end
					end
				elseif itemRarity == 7 then
					if #slotStatus == 2 then
						local multipleSlot = GH_Globals.itemSlot[itemLootEquipLoc]
						for a = 1, #multipleSlot do
							if slotStatus[a] == false then
								local _, equipedItem = GetItemInfoPers(charInventory[multipleSlot[a]])
								table.insert(result, diffItemValueTemplate(GetItemStatDelta(lootItem, equipedItem)))
							else
								table.insert(result, diffItemValueTemplate(GetItemStats(lootItem)))
							end
						end
					else
						if slotStatus[1] == false then
							if charInventory[GH_Globals.itemSlot[itemLootEquipLoc]] ~= nil then --------------------------------    A CORRIGER ! -------------------------------
								local _, equipedItem = GetItemInfoPers(charInventory[GH_Globals.itemSlot[itemLootEquipLoc]])
								table.insert(result, diffItemValueTemplate(GetItemStatDelta(lootItem, equipedItem)))
							end
						else
							table.insert(result, diffItemValueTemplate(GetItemStats(lootItem)))
						end
					end
				end
			end
			templateWeight = GH_Globals[specialisationID + GHAMR]
			scanBag()
			return result
		end
		templateWeight = GH_Globals[specialisationID + GHAMR]
		scanBag()
	end
end

-- desc : Inventoriage des sacs
-- entrée : 
-- sortie : 
-- commentaire :
function scanBag()
	local count = 0
	for bag = 0,4 do
		for slot = 1,GetContainerNumSlotsPers(bag) do
			local itemLink = GetContainerItemLinkPers(bag, slot)
    		--Faire un getinventoryitemid pour tester si y'a bien un item et ensuite GetInventoryItemLinkPers pour recup le lien et non pas l'id de transmog
    		if itemLink ~= nil then
    			local _, _, _, _, _, itemType, _, _, itemEquipLoc, _, itemSellPrice = GetItemInfoPers(itemLink)
    			if itemType == L["armor"] or itemType == L["weapon"] then
    				table.insert(bagInventory, itemLink)
    				count  = count + 1  --------------------------------------------- à virer ?!
    			end
    		end
    	end
    end
end

function equipItem( )
	scanBag()
	for slot = 1,GetContainerNumSlotsPers(numBag) do
		local itemLink = GetContainerItemLinkPers(numBag, slot)
		if itemLink ~= nil then
			local weightCalcResult = weightCalculation(itemLink)
			if weightCalcResult[1] ~= nil and weightCalcResult[1] > 0 or weightCalcResult[2] ~= nil and weightCalcResult[2] > 0 then
				local name, link, _, _, _, itemType, _, _, itemEquipLoc, _, _ = GetItemInfoPers(itemLink)
				if itemEquipLoc == "INVTYPE_TRINKET" then
					if weightCalcResult[1] > weightCalcResult[2]then
						EquipItemByName(name, 13)
					else
						EquipItemByName(name, 14)
					end
				elseif itemEquipLoc == "INVTYPE_FINGER" then
					if weightCalcResult[1] > weightCalcResult[2] then
						EquipItemByName(name, 11)
					else
						EquipItemByName(name, 12)
					end
				elseif itemEquipLoc == "INVTYPE_WEAPON" then
					if weightCalcResult[1] > weightCalcResult[2] then
						EquipItemByName(name, 16)
					else
						EquipItemByName(name, 17)
					end
				end
				EquipItemByName(name)
			end
		end
	end
end

function isInTable(array, data)
	local valid = {}
	for i = 1, #array do
		valid[array[i]] = true
	end
	if valid[data] then
		return true
	else
		return false
	end
end

GameTooltip:HookScript('OnTooltipSetItem', function(self)
	if GHActivated == true then
		local _, item = self:GetItem()
		if item then
			local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfoPers(item)
			local result = weightCalculation(item)
			if #result == 1 then
				if result[1] < 0 then
					self:AddLine(L["itemLessThanGeneral"])
				elseif result[1] == 0 then
					self:AddLine("Cet item est équivalent à celui équipé")
				else
					self:AddLine(L["itemBetterThanGeneral"]..math.floor(result[1]))
				end
			elseif #result == 2 then
				if itemEquipLoc == "INVTYPE_TRINKET" then
					if result[1] < 0 then
						self:AddLine(L["itemLessThan"].." Trinket0")-- avec une valeur de "..math.floor(value))
					elseif result[1] == 0 then
						self:AddLine("Cet item est équivalent au Trinket0 équipé")
					else
						self:AddLine(L["itemBetterThan"].." Trinket0 "..L["itemBetterThan2"]..math.floor(result[1]))
					end
					if result[2] < 0 then
						self:AddLine(L["itemLessThan"].." Trinket1")-- avec une valeur de "..math.floor(value))
					elseif result[2] == 0 then
						self:AddLine("Cet item est équivalent au Trinket1 équipé")
					else
						self:AddLine(L["itemBetterThan"].." Trinket1 "..L["itemBetterThan2"]..math.floor(result[2]))
					end
				elseif itemEquipLoc == "INVTYPE_FINGER" then
					if result[1] < 0 then
						self:AddLine(L["itemLessThan"].." Finger0")-- avec une valeur de "..math.floor(value))
					elseif result[1] == 0 then
						self:AddLine("Cet item est équivalent au Finger0 équipé")
					else
						self:AddLine(L["itemBetterThan"].." Finger0 "..L["itemBetterThan2"]..math.floor(result[1]))
					end
					if result[2] < 0 then
						self:AddLine(L["itemLessThan"].." Finger1")-- avec une valeur de "..math.floor(value))
					elseif result[2] == 0 then
						self:AddLine("Cet item est équivalent au Finger1 équipé")
					else
						self:AddLine(L["itemBetterThan"].." Finger1 "..L["itemBetterThan2"]..math.floor(result[2]))
					end
				elseif itemEquipLoc == "INVTYPE_WEAPON" then
					if result[1] < 0 then
						self:AddLine(L["itemLessThan"].." Main Droite")-- avec une valeur de "..math.floor(value))
					elseif result[1] == 0 then
						self:AddLine("Cet item est équivalent à la main droite équipé")
					else
						self:AddLine(L["itemBetterThan"].." Main Droite "..L["itemBetterThan2"]..math.floor(result[1]))
					end
					if result[2] < 0 then
						self:AddLine(L["itemLessThan"].." Main Gauche")-- avec une valeur de "..math.floor(value))
					elseif result[2] == 0 then
						self:AddLine("Cet item est équivalent à la Main Gauche équipé")
					else
						self:AddLine(L["itemBetterThan"].." Main Gauche "..L["itemBetterThan2"]..math.floor(result[2]))
					end
				else
					self:AddLine(L["itemLessThanGeneral"])
				end
			end

		end
	end
end)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

----------------------
-- Helper functions --				Pour ceux qui se demandent, oui, je dessine mieux en ASCII que je ne code
----------------------


--------------------
-- Slash commands --
--------------------
local slashCmdFunc = {
	voidcommand = function ( msg )
		print(L["slashCmdInfo"])
	end,
	help = function ( msg )
		print(L["configHelpInfo"])
		print(L["stateHelpInfo"])
	end,
	state = function ( msg )
		local etatAddon = nil
		local etatSellGrey = nil
		local etatAutoGreed = nil
		local etatAutoAcceptQuestReward = nil
		local etatAutoNeed = nil
		local etatAutoEquipInstanceLootStuff = nil
		local etatAutoEquipWhenChangeSpe = nil

		if GHSellGreyActivated then
			etatSellGrey = L["activeeVert"]
		else
			etatSellGrey = L["desactiveeRouge"]
		end

		if GHAutoGreed then
			etatAutoGreed = L["activeeVert"]
		else
			etatAutoGreed = L["desactiveeRouge"]
		end

		if GHAutoAcceptQuestReward then
			etatAutoAcceptQuestReward = L["activeeVert"]
		else
			etatAutoAcceptQuestReward =L["desactiveeRouge"]
		end

		if GHAutoNeed then
			etatAutoNeed = L["activeeVert"]
		else
			etatAutoNeed = L["desactiveeRouge"]
		end

		if GHAutoEquipLootStuff then
			etatAutoEquipInstanceLootStuff = L["activeeVert"]
		else
			etatAutoEquipInstanceLootStuff = L["desactiveeRouge"]
		end

		if GHAutoEquipWhenChangeSpe then
			etatAutoEquipWhenChangeSpe = L["activeeVert"]
		else
			etatAutoEquipWhenChangeSpe = L["desactiveeRouge"]
		end

		if GHActivated then
			etatAddon = "|cFF00FF00activé|r"
		else
			etatAddon = "|cFFFF0000désactivé|r"
			etatSellGrey = L["desactiveeRouge"]
			etatAutoGreed = L["desactiveeRouge"]
			etatAutoAcceptQuestReward = L["desactiveeRouge"]
			etatAutoNeed = L["desactiveeRouge"]
			etatAutoEquipInstanceLootStuff = L["desactiveeRouge"]
			etatAutoEquipWhenChangeSpe = L["desactiveeRouge"]
		end

		------------------------- Rajouter réparation + minimap button
		if etatAutoGreed ~= nil and etatAddon ~= nil and etatSellGrey ~= nil and etatAutoAcceptQuestReward ~= nil and etatAutoNeed ~= nil and etatAutoEquipInstanceLootStuff ~= nil and etatAutoEquipWhenChangeSpe ~= nil then
			print(L["state1"]..etatAddon..L["state2"]..etatSellGrey..L["state3"]..etatAutoGreed..L["state4"]..etatAutoAcceptQuestReward..L["state5"]..etatAutoNeed..L["state6"]..etatAutoEquipInstanceLootStuff..L["state7"]..etatAutoEquipWhenChangeSpe.."|cFFFFFF00.|r")
		else
			print(L["stateError"])
		end
	end,
	list = function ( msg )
		scanBag()
		scanCharacter()
	 end,

	config = function ( msg )
		InterfaceOptionsFrame_OpenToCategory(frameInterface)
		InterfaceOptionsFrame_OpenToCategory(frameInterface)
		end,
	}

-- Activation de /cmd
local cmd1 = "/gh"
local cmd2 = "/gearhelper"
SLASH_GEARHELPER1 = cmd1:lower()
SLASH_GEARHELPER2 = cmd2:lower()
-- Fin d'activation des /cmd
-- Déclaration des /cmd
SlashCmdList["GEARHELPER"] = function ( msg )
	local instruction = msg:match("%a+")
	if instruction then 
		instruction = instruction:lower() 
	end
	if msg == "" then
		InterfaceOptionsFrame_OpenToCategory(frameInterface)
		InterfaceOptionsFrame_OpenToCategory(frameInterface)
	elseif slashCmdFunc[instruction] then
		slashCmdFunc[instruction](msg)
	else
		slashCmdFunc["voidcommand"](msg)
	end
--end
end
-- Fin déclaration des /cmd

-------------------
-- Event handler --
-------------------

-- Se déclenche quand les addons se chargent
function allEvents:ADDON_LOADED( name )
	if name == addonName then
		-- charge le préfix de l'addon (ou un truc du genre)
		RegisterAddonMessagePrefix(prefix) 

		-- Active l'addon par défaut lors de la première connexion après l'installation
		if GHActivated == nil or GHSellGreyActivated == nil or GHAutoGreed == nil or GHAutoAcceptQuestReward == nil or GHAutoNeed == nil or GHAutoEquipLootStuff == nil or GHAutoEquipWhenChangeSpe == nil or GHAMR == nil or GHMinimapButton == nil or GHAutoRepair == nil then
			setDefault() 
		end

		-- Affiche à chaque connection l'état de l'addon
		if GHActivated == true then 
			print(L["setOn"]) 
			--sendAskVersion()
		else 
			print(L["setOff"]) 
		end
	end
end

-- Se déclenche quand un message d'addon arrive
function allEvents:CHAT_MSG_ADDON( prefixMessage, message, channel, sender )
	if prefixMessage == prefix then
		if sender:find("-")then
			local emeteur = sender:sub(0, (sender:find("-") - 1))
		else 
			local emeteur = sender
		end
		if GHActivated == true then
			if emeteur ~= GetUnitName("player") then
				local prefVersion = message:sub(0, (message:find(";") - 1))
				if prefVersion == "answerVersion" then
					local vVersion = message:sub(message:find(";")+1, #message)
						versionCible = vVersion
						receiveAnswer(vVersion, sender)
				end
				if prefVersion == "askVersion" then
					sendAnswerVersion()
				end
			end
		end
	end
end

-- Quand un objet attérie dans l'inventaire --bag : 0, 1, 2, 3 ou 4
function allEvents:ITEM_PUSH( bag, icone )
	
	if GHActivated then
		scanCharacter()
		scanBag()
	end

	--print("bag : "..bag)      --------------------        DEBUG MODE        --------------------

	if GHAutoEquipLootStuff then
		if bag == 23 then
			numBag = 4
		elseif bag == 22 then
			numBag = 3
		elseif bag == 21 then
			numBag = 2
		elseif bag == 20 then
			numBag = 1
		else
			numBag = bag
		end

		--print("numBag : "..numBag)      --------------------        DEBUG MODE        --------------------

		waitEquipTimer = time()
		waitEquipFrame:Show()
	end
end

-- Evenement se déclenche quanduand un arrive sur la page de la quête terminée (la ou il faut choisir la récompense)
function allEvents:QUEST_COMPLETE()
	local nbRecompenses = GetNumQuestChoicesPers()

	 local weightTable = {}
	 local prixTable = {}
	 local altTable = {}

	 local itemName1, itemLink1, itemRarity1, itemLevel1, itemMinLevel1, itemType1, itemSubType1, itemStackCount1, itemEquipLoc1, itemTexture1, itemSellPrice1 = nil

	if GHAutoAcceptQuestReward then
		if GetNumQuestChoicesPers() < 1 then
			GetQuestRewardPers()
		elseif GetNumQuestChoicesPers() == 1 then
			GetQuestRewardPers(1)
		else
			local objetI = GetQuestItemLinkPers("choice", 1)

			for i = 1, GetNumQuestChoicesPers() do
				objetI = GetQuestItemLinkPers("choice", i)
				itemName1, itemLink1, itemRarity1, itemLevel1, itemMinLevel1, itemType1, itemSubType1, itemStackCount1, itemEquipLoc1, itemTexture1, itemSellPrice1 = GetItemInfoPers(objetI)
				local res = weightCalculation(objetI)
				if res[1] ~= nil and res[1] > 0 or res[2]~= nil and res[2] > 0 then
					if res[1] > 0 then
						table.insert(weightTable, res[1])
					else
						table.insert(weightTable, res[2])
					end
				else
					table.insert(weightTable, -10)

					table.insert(prixTable, itemSellPrice1)
					table.insert(altTable, itemSellPrice1, objetI)
				end
			end

			local maxWeight = weightTable[1]
			local keyWeight = 1
			local maxPrix = prixTable[1]
			local keyPrix = 1

			for i = 1, #weightTable do
				if weightTable[i] > maxWeight then
					maxWeight = weightTable[i]
					keyWeight = i
				end
			end

			for i = 1, #prixTable do
				if prixTable[i] > maxPrix then
					maxPrix = prixTable[i]
					keyPrix = i
				end
			end



			local prixTriee = prixTable
			table.sort( prixTriee )


			if itemSubType1 ~= nil and itemSubType1 ~= L["reliqueAP"] and (itemType1 ~= "Gemme" and itemType1 ~= "Gem") then
					if maxWeight > 0 then
						GetQuestRewardPers(keyWeight) -- normalement c'est bon
						do return end
					end
				GetQuestRewardPers(keyPrix) -- normalement c'est bon
			end
		end
	end
end

-- Evenement se déclenche à chaque écran de chargement
function allEvents:PLAYER_ENTERING_WORLD()
	UIGearHelper()
	if GHActivated == true then
		specialisationID, specName, description, icon, background, role, primaryStat = GetSpecializationInfoPers(GetSpecializationPers(), false, false, UnitName("player"), UnitSex("player"))
		sendAskVersion()
		scanCharacter()
		scanBag()
	end

	if GHMinimapButton then
	    MyMod_MinimapButton:Show()
	else
	    MyMod_MinimapButton:Hide()
	    MyMod_MinimapButton:Hide()
	end

end

-- Evenement se déclanche quand la fenêtre besoin/cupi pop en donjon
function allEvents:START_LOOT_ROLL(number, timer)
	-- classeEN est la même, quelle que soit la langue du client
	local classeFR, classeEN, classeNumber = UnitClass("player")
	local link, name, _, _, bindOnPickUp, canNeed, canGreed  = GetLootRollItemInfoPers(number)

	-- number = ID de l'id du roll (1, 2, 3 ....)
	-- rollType = 0 pass, 1 need, 2 cupi, 3 dez
	-- ConfirmLootRollPers(number, rollType)


	-- faire ça pour jouet et mascottes aussi
	if GHAutoNeed then
		if testSiMonture(name) then
			ConfirmLootRollPers(number, 1)
			UIErrorsFrame:AddMessage(L["iNeededOn"]..name, 0.0, 1.0, 0.0, 80)            -----------          DEBUG MODE        -----------
		end
	end 
	if GHAutoGreed then
		if canNeed == false then
			ConfirmLootRollPers(number, 2)
		end
	end

	specID = GetLootSpecializationPers()
	if specID == 0 then
		specID = specialisationID
	end
	templateWeight = GH_Globals[specID + GHAMR]
	scanBag()

	local weightCalcResult = weightCalculation(link)
	if canNeed then
		if GHAutoNeed then
			if (weightCalcResult[1] ~= nil and weightCalcResult[1] > 0) or (weightCalcResult[2] ~= nil and weightCalcResult[2] > 0) then
				ConfirmLootRollPers(number, 1)
				UIErrorsFrame:AddMessage(L["iNeededOn"]..name, 0.0, 1.0, 0.0, 150)          -----------          DEBUG MODE        -----------
				--UIErrorsFrame:AddMessage("Pourquoi t'as need ça gros con ?", 1.0, 0.0, 0.0, 150)
			elseif GHAutoGreed then
				ConfirmLootRollPers(number, 2)
			end
		end
	else
		if GHAutoGreed then
			ConfirmLootRollPers(number, 2)
		end
	end
	templateWeight = GH_Globals[specialisationID + GHAMR]
	scanBag()
end

-- Se déclenche quand l'inventaire du joueur est modifié ?
function allEvents:UNIT_INVENTORY_CHANGED( joueur )
	if joueur == "player" and GHActivated == true then
		scanCharacter()
		scanBag()
	end
end

-- Evenement se déclenche quand on ouvre la fenetre d'un vendeur
function allEvents:MERCHANT_SHOW()
	if GHSellGreyActivated then
		for bag = 0, 4 do
			for slot = 1,GetContainerNumSlotsPers(bag) do
				if GetContainerItemIDPers(bag, slot) ~= nil then
					id = GetContainerItemIDPers(bag, slot)
					if id then
						if testSiObjetGris(id) then
							UseContainerItemPers(bag, slot)
						end
					end
				end
			end
		end
	end

	if CanMerchantRepair() then
		local argentPossedee = GetMoney()
		local prix = GetRepairAllCost()
		if IsInGuild() and CanGuildBankRepair() then
			local droitGuilde = GetGuildBankWithdrawMoney()
			local argentGuilde = GetGuildBankMoney()
		end
		if prix > 0 then
			if GHAutoRepair == 1 then
				if argentPossedee >= prix then
					RepairAllItems(false)

					print(L["repairCost"]..math.floor(prix/10000)..L["dot"]..math.floor((prix % 10000) / 100)..L["gold"])
				else
					print(L["CantRepair"])
				end
			elseif GHAutoRepair == 2 then
				if droitGuilde == -1 or (droitGuilde > argentGuilde and argentGuilde > prix) then
					RepairAllItems(true)
					print(L["guildRepairCost"]..math.floor(prix/10000)..L["dot"]..math.floor((prix % 10000) / 100)..L["gold"])
				else
					if argentPossedee >= prix then
						RepairAllItems(false)
						print(L["repairCost"]..math.floor(prix/10000)..L["dot"]..math.floor((prix % 10000) / 100)..L["gold"])
					else
						print(L["CantRepair"])
					end
				end
			end
		end
	end
end

-- Se déclenche au changement de spé
function allEvents:ACTIVE_TALENT_GROUP_CHANGED()
	if GHAutoEquipWhenChangeSpe then
		waitSpeTimer = time()
		waitSpeFrame:Show()
	end
end
--------------------------------------------
-- xxxxx xxxxxxx --      -- xxxxx xxxxxxx --
--------------------------------------------

for event, _ in pairs(allEvents) do
	eventHandler:RegisterEvent(event)
end
eventHandler:SetScript("OnEvent", function ( self, event, ... )
	if GHActivated or GHActivated == nil then
		allEvents[event](self, ...)
	end
end)


local function createButton( nomButton, posX, posY, text )
	nomButton = CreateFrame("CheckButton", tostring( nomButton ), frameInterface, "UICheckButtonTemplate")	
	nomButton:SetPoint("CENTER", posX + decallageX, posY + decallageY)
	nomButton.text:SetText(text)
	nomButton:SetFrameStrata("HIGH")
	nomButton:SetScale(1.25)
end

function UIGearHelper() 
	if frameInterface ~= nil then
		frameInterface = nil
	end

	frameInterface = CreateFrame("Frame", nil, InterfaceOptionsFramePanelContainer)
	frameInterface.name = "GearHelper"
	frameInterface:Hide()
	frameInterface:SetScript("OnShow", function(frame)
		local decallageX = -120
		local decallageY = 120

		local checkGHActivated = CreateFrame("CheckButton", "GHActivatedButton", frameInterface, "UICheckButtonTemplate")	
	checkGHActivated:SetPoint("CENTER", -150 + decallageX, decallageY + 90)
	checkGHActivated.text:SetText(L["checkGHActivated"])
	checkGHActivated:SetFrameStrata("HIGH")
	--checkGHActivated:SetScale(1.25)
	if GHActivated then
		checkGHActivated:SetChecked(true)
	else
		checkGHActivated:SetChecked(false)
	end


	--createButton(checkGHSellGreyActivated, -150, 60, L["checkGHSellGreyActivated"])
	local checkGHSellGreyActivated = CreateFrame("CheckButton", "GHSellGreyButton", frameInterface, "UICheckButtonTemplate")	
	checkGHSellGreyActivated:SetPoint("CENTER", -150 + decallageX, decallageY + 60)
	checkGHSellGreyActivated.text:SetText(L["checkGHSellGreyActivated"])
	checkGHSellGreyActivated:SetFrameStrata("HIGH")
	--checkGHSellGreyActivated:SetScale(1.25)
	if GHSellGreyActivated then
		checkGHSellGreyActivated:SetChecked(true)
	else
		checkGHSellGreyActivated:SetChecked(false)
	end

	local checkGHAutoGreed = CreateFrame("CheckButton", "GHAutoGreedButton", frameInterface, "UICheckButtonTemplate")	
	checkGHAutoGreed:SetPoint("CENTER", -150 + decallageX, decallageY + 30)
	checkGHAutoGreed.text:SetText(L["checkGHAutoGreed"])
	checkGHAutoGreed:SetFrameStrata("HIGH")
	--checkGHAutoGreed:SetScale(1.25)
	if GHAutoGreed then
		checkGHAutoGreed:SetChecked(true)
	else
		checkGHAutoGreed:SetChecked(false)
	end

	local checkGHAutoAcceptQuestReward = CreateFrame("CheckButton", "GHAutoAcceptQuestRewardButton", frameInterface, "UICheckButtonTemplate")	
	checkGHAutoAcceptQuestReward:SetPoint("CENTER", -150 + decallageX, decallageY + 0)
	checkGHAutoAcceptQuestReward.text:SetText(L["checkGHAutoAcceptQuestReward"])
	checkGHAutoAcceptQuestReward:SetFrameStrata("HIGH")
	--checkGHAutoAcceptQuestReward:SetScale(1.25)
	if GHAutoAcceptQuestReward then
		checkGHAutoAcceptQuestReward:SetChecked(true)
	else
		checkGHAutoAcceptQuestReward:SetChecked(false)
	end

	local checkGHAutoNeed = CreateFrame("CheckButton", "GHAutoNeedButton", frameInterface, "UICheckButtonTemplate")	
	checkGHAutoNeed:SetPoint("CENTER", -150 + decallageX, decallageY + -30)
	checkGHAutoNeed.text:SetText(L["checkGHAutoNeed"])
	checkGHAutoNeed:SetFrameStrata("HIGH")
	--checkGHAutoNeed:SetScale(1.25)
	if GHAutoNeed then
		checkGHAutoNeed:SetChecked(true)
	else
		checkGHAutoNeed:SetChecked(false)
	end

	local checkGHAutoEquipLootStuff = CreateFrame("CheckButton", "GHAutoEquipLootStuffButton", frameInterface, "UICheckButtonTemplate")	
	checkGHAutoEquipLootStuff:SetPoint("CENTER", -150 + decallageX, decallageY + -60)
	checkGHAutoEquipLootStuff.text:SetText(L["checkGHAutoEquipLootStuff"])
	checkGHAutoEquipLootStuff:SetFrameStrata("HIGH")
	--checkGHAutoEquipLootStuff:SetScale(1.25)
	if GHAutoEquipLootStuff then
		checkGHAutoEquipLootStuff:SetChecked(true)
	else
		checkGHAutoEquipLootStuff:SetChecked(false)
	end

	local checkGHAutoEquipWhenChangeSpe = CreateFrame("CheckButton", "GHAutoEquipWhenChangeSpeButton", frameInterface, "UICheckButtonTemplate")	
	checkGHAutoEquipWhenChangeSpe:SetPoint("CENTER", -150 + decallageX, decallageY + -90)
	checkGHAutoEquipWhenChangeSpe.text:SetText(L["checkGHAutoEquipWhenChangeSpe"])
	checkGHAutoEquipWhenChangeSpe:SetFrameStrata("HIGH")
	--checkGHAutoEquipWhenChangeSpe:SetScale(1.25)
	if GHAutoEquipWhenChangeSpe then
		checkGHAutoEquipWhenChangeSpe:SetChecked(true)
	else
		checkGHAutoEquipWhenChangeSpe:SetChecked(false)
	end

	local hideMinimapButton = CreateFrame("CheckButton", "hideMinimapButton", frameInterface, "UICheckButtonTemplate")	
	hideMinimapButton:SetPoint("CENTER", -150 + decallageX, decallageY + -120)
	hideMinimapButton.text:SetText(L["mmButton"])
	hideMinimapButton:SetFrameStrata("HIGH")
	--checkGHAutoEquipWhenChangeSpe:SetScale(1.25)
	if GHMinimapButton then
		hideMinimapButton:SetChecked(true)
	else
		hideMinimapButton:SetChecked(false)
	end



	local radioDoNotRepairButton = CreateFrame("CheckButton", "radioDoNotRepairButton", frameInterface, "UIRadioButtonTemplate")
	radioDoNotRepairButton:SetPoint("CENTER", -150 + decallageX, decallageY + -150)
	radioDoNotRepairButton.text:SetText(L["DNR"])
	radioDoNotRepairButton:SetFrameStrata("HIGH")
	--radioDoNotRepairButton:SetScale(1.25)

	local radioAutoRepairButton = CreateFrame("CheckButton", "radioAutoRepairButton", frameInterface, "UIRadioButtonTemplate")
	radioAutoRepairButton:SetPoint("CENTER", 70 + decallageX, decallageY + -150)
	radioAutoRepairButton.text:SetText(L["AutoRepair"])
	radioAutoRepairButton:SetFrameStrata("HIGH")
	--radioAutoRepairButton:SetScale(1.25)

	local radioAutoRepairGuildButton = CreateFrame("CheckButton", "radioAutoRepairGuildButton", frameInterface, "UIRadioButtonTemplate")
	radioAutoRepairGuildButton:SetPoint("CENTER", 250 + decallageX, decallageY + -150)
	radioAutoRepairGuildButton.text:SetText(L["GuildAutoRepair"])
	radioAutoRepairGuildButton:SetFrameStrata("HIGH")
	--radioAutoRepairGuildButton:SetScale(1.25)
	if GHAutoRepair == 0 then
		radioDoNotRepairButton:SetChecked(true)
		radioAutoRepairButton:SetChecked(false)
		radioAutoRepairGuildButton:SetChecked(false)
	end
	if GHAutoRepair == 1 then
		radioDoNotRepairButton:SetChecked(false)
		radioAutoRepairButton:SetChecked(true)
		radioAutoRepairGuildButton:SetChecked(false)
	end
	if GHAutoRepair == 2 then
		radioDoNotRepairButton:SetChecked(false)
		radioAutoRepairButton:SetChecked(false)
		radioAutoRepairGuildButton:SetChecked(true)
	end




	local radioAMRButton = CreateFrame("CheckButton", "radioAMRButton", frameInterface, "UIRadioButtonTemplate")
	radioAMRButton:SetPoint("CENTER", -150 + decallageX, decallageY + 120)
	radioAMRButton.text:SetText(L["radioAMRButton"])
	radioAMRButton:SetFrameStrata("HIGH")
	--radioAMRButton:SetScale(1.25)
	

	local radioNoxxicButton = CreateFrame("CheckButton", "radioNoxxicButton", frameInterface, "UIRadioButtonTemplate")
	radioNoxxicButton:SetPoint("CENTER", 150 + decallageX, decallageY + 120)
	radioNoxxicButton.text:SetText(L["radioNoxxicButton"])
	radioNoxxicButton:SetFrameStrata("HIGH")
	--radioNoxxicButton:SetScale(1.25)
	if GHAMR == 1000 then
		radioAMRButton:SetChecked(true)
		radioNoxxicButton:SetChecked(false)
	elseif GHAMR == 0 then
		radioNoxxicButton:SetChecked(true)
		radioAMRButton:SetChecked(false)
	end

	radioNoxxicButton:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			GHAMR = 0
			radioAMRButton:SetChecked(false)
			radioNoxxicButton:SetChecked(true)
			scanCharacter()
			scanBag()
		else
			GHAMR = 0
			radioAMRButton:SetChecked(false)
			radioNoxxicButton:SetChecked(true)
			scanCharacter()
			scanBag()
		end
	end)

	radioAMRButton:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			GHAMR = 0 ---------------------------------------------- METTRE à 1000 QUAND AMR EST UPDATE
			radioNoxxicButton:SetChecked(false)
			radioAMRButton:SetChecked(true)
			scanCharacter()
			scanBag()
		else
			GHAMR = 0 ---------------------------------------------- METTRE à 1000 QUAND AMR EST UPDATE
			radioNoxxicButton:SetChecked(false)
			radioAMRButton:SetChecked(true)
			scanCharacter()
			scanBag()
		end
	end)

	radioDoNotRepairButton:SetScript("OnClick", function ( self,event, arg1 )
		if self:GetChecked() then
			radioDoNotRepairButton:SetChecked(true)
			radioAutoRepairButton:SetChecked(false)
			radioAutoRepairGuildButton:SetChecked(false)
			setGHAutoRepair(0)
		end
	end)
	radioAutoRepairButton:SetScript("OnClick", function ( self,event, arg1 )
		if self:GetChecked() then
			radioDoNotRepairButton:SetChecked(false)
			radioAutoRepairButton:SetChecked(true)
			radioAutoRepairGuildButton:SetChecked(false)
			setGHAutoRepair(1)
		end
	end)
	radioAutoRepairGuildButton:SetScript("OnClick", function ( self,event, arg1 )
		if self:GetChecked() then
			radioDoNotRepairButton:SetChecked(false)
			radioAutoRepairButton:SetChecked(false)
			radioAutoRepairGuildButton:SetChecked(true)
			setGHAutoRepair(2)
		end
	end)
	
	checkGHActivated:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			setActivated(true)
		else
			setActivated(false)
		end
	end)

	checkGHSellGreyActivated:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			setGHSellGreyActivated(true)
		else
			setGHSellGreyActivated(false)
		end
	end)

	checkGHAutoGreed:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			setGHAutoGreed(true)
		else
			setGHAutoGreed(false)
		end
	end)

	checkGHAutoAcceptQuestReward:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			setGHAutoAcceptQuestReward(true)
		else
			setGHAutoAcceptQuestReward(false)
		end
	end)

	checkGHAutoNeed:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			setGHAutoNeed(true)
		else
			setGHAutoNeed(false)
		end
	end)

	checkGHAutoEquipLootStuff:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			setGHAutoEquipLootStuff(true)
		else
			setGHAutoEquipLootStuff(false)
		end
	end)

	hideMinimapButton:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			GHMinimapButton = true
			MyMod_MinimapButton:Show()
		else
			MyMod_MinimapButton:Hide()
			GHMinimapButton = false
		end
	end)

	checkGHAutoEquipWhenChangeSpe:SetScript("OnClick", function(self,event,arg1)
		if self:GetChecked() then
			setGHAutoEquipWhenChangeSpe(true)
		else
			setGHAutoEquipWhenChangeSpe(false)
		end
	end)
	end)
InterfaceOptions_AddCategory(frameInterface)
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------



--------------


-- pour chaques piece de stuff
-- faire une recherche dans l'inventaire
-- regarder s'il existe un stuff du même type
-- si oui, regarder s'il est meilleurs que celui qu'on à
-- si oui l'équiper
-- si non, le laisser dans l'inventaire
-- fonction weightCalculation si finger ou trinket abs ca doit planter
--recup le retour de la tabcaracter et pour chaque faire un weightCalculation ca economise des lignes pour trinket et bague

-- desc : 
-- entrée : 
-- sortie : 
-- commentaire :


--/script print(GetSpecializationInfoPers(GetSpecializationPers(), false, false, UnitName("player"), UnitSex("player")))
